/***********************************************************************\
* fathook.c - Input queue monitor hook interface library
*
* This dynlink is needed because global input hooks must reside in a DLL.
\***********************************************************************/

#define INCL_WINHOOKS
#define INCL_WININPUT

#include <os2.h>

VOID EXPENTRY QJournalRecordHook(HAB, PQMSG);
BOOL EXPENTRY InstallFatHook(HAB, HWND);
VOID EXPENTRY ReleaseFatHook(void);
VOID EXPENTRY Initdll(HMODULE);

static HMODULE qhmod;              /* dynlink module handle            */
static HWND hwnd;                  /* window to invalidate             */
static HAB habt = NULLHANDLE;      /* Anchor block                     */

VOID EXPENTRY QJournalRecordHook(hab,lpqmsg)
HAB hab;
PQMSG lpqmsg;
{
	//hab;
	if (lpqmsg->msg == WM_MOUSEMOVE) WinInvalidateRect(hwnd,NULL,TRUE);
}

BOOL EXPENTRY InstallFatHook(hab,thehwnd)
HAB hab;
HWND thehwnd;
{
	if (habt) return FALSE;
	hwnd = thehwnd;
	habt = hab;
	WinSetHook(hab,NULLHANDLE,HK_JOURNALRECORD,(PFN)QJournalRecordHook,qhmod);
	return TRUE;
}

VOID EXPENTRY ReleaseFatHook()
{
	WinReleaseHook(habt,NULLHANDLE,HK_JOURNALRECORD,(PFN)QJournalRecordHook,qhmod);
	habt = NULLHANDLE;
}


VOID EXPENTRY Initdll(hmod)
HMODULE hmod;
{
	qhmod = hmod;
}
